#if !defined  HAVE_SUBSETDEBRUIJN_H__
#define       HAVE_SUBSETDEBRUIJN_H__


#include "debruijn.h"
#include "shift.h"


class subset_debruijn : public debruijn
{
protected:
    ulong *x;
    ulong el_;
    ulong ct_;

public:
    subset_debruijn(ulong nn)
        : debruijn(2, nn)
    {
        x = NEWOP(ulong, nmax_);
        init();
    }

    ~subset_debruijn()  { delete [] x;}


    void init(ulong nn=0)
    {
        if ( 0!=nn )  n_ = nn;
        fill(x, nmax_, 1UL);
        el_ = 0;
        ct_ = 1UL<<n_;
        debruijn::init(2, n_);
//        do { el_ = debruijn::next(); }
//        while ( 0==el_ );
//        sync_x();
    }


    ulong next()  // return  new element
    {
        el_ = debruijn::next();
        sync_x();
        return  el_;
    }

    const ulong * data()  { return x; }


protected:
    void sync_x()
    {
        --ct_;
        shift_right(x, n_, 1);
        x[0] = el_;
    }

private:
    int done()  const;  // forbidden (exists in base class)
};
// -------------------------



#endif  // !defined HAVE_SUBSETDEBRUIJN_H__
